//
//  ChocoLayerText.h
//  ChocoFlopX
//
//  Created by Santiago Lema on 06.11.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "ChocoLayer.h"
#import "ChocoTextView.h"

@interface ChocoLayerText : ChocoLayer 
{
	NSWindow* offscreenWindow;
	NSRect _normalSize;
	
//	CIImageAccumulator* accuTextRendered;
	CGRect textFrame;
	BOOL textChanged;
	CGRect previousTextVisibleRect;
	CIImage* lastValidImage;
	
//	NSImage* pdfImage;
	//NSTextView* textView;
	ChocoTextView* textView;
	NSLock* renderTextLock;
	

	BOOL autolabel;
	NSRect textBoundsBeforeDrag;

		

}

-(void) setAutolabel:(BOOL)a;
-(BOOL) getAutolabel;

-(void) setTextBoundsBeforeDrag:(NSRect)r;
-(NSRect) getTextBoundsBeforeDrag;

-(void) setTextView:(NSTextView*)v;
-(IBAction) restoreTextView:(NSTextView*) v;
-(NSTextView*) getTextView;
-(void) setTextData:(NSData*) rtfData;
-(NSData*) getTextData ;
-(IBAction) restoreTextData:(NSData*) rtfData;
-(void) createEmptyTextAtPoint:(NSPoint)pt withWidth:(float)w andHeight:(float)h render:(BOOL) render;
//-(CIImage*) getTextAsImage	;
-(void) textNeedsRender;
-(BOOL) updateTextRenderedNOW;

-(void) updateLabelFromTextView;
-(BOOL)isPointInsideText:(NSPoint) pt;
-(void)loadRTFfromPath: (NSString*) txtPath renderImmediately:(BOOL)immediateRender createTextView:(BOOL)createView;
-(void) setTextViewSizeToWidth:(int) maxX andHeight:(int) maxY;
//-(void)convertToPixels;

-(NSRect) getTextViewBounds;
//-(CIImageAccumulator*) getTextAccu;

-(ChocoTextView*) allocTextViewWithCorrectSettingsInFrame:(NSRect)rView;
-(void) createCloneOfTextView:(NSTextView*)v prerenderedImage:(CIImage*) accuClone;
-(void) textContentChanged;
-(BOOL) checkNormalSizeIsSet;
-(IBAction) drawingOver:(id)sender;

@end
